
void _efl_boolean_model_boolean_add(Eo *obj, Efl_Boolean_Model_Data *pd, const char *name, Eina_Bool default_value);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_boolean_model_boolean_add, EFL_FUNC_CALL(name, default_value), const char *name, Eina_Bool default_value);

void _efl_boolean_model_boolean_del(Eo *obj, Efl_Boolean_Model_Data *pd, const char *name);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_boolean_model_boolean_del, EFL_FUNC_CALL(name), const char *name);

Eina_Iterator *_efl_boolean_model_boolean_iterator_get(Eo *obj, Efl_Boolean_Model_Data *pd, const char *name, Eina_Bool request);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_boolean_model_boolean_iterator_get, Eina_Iterator *, NULL, EFL_FUNC_CALL(name, request), const char *name, Eina_Bool request);

Eina_Iterator *_efl_boolean_model_efl_model_properties_get(const Eo *obj, Efl_Boolean_Model_Data *pd);


Eina_Future *_efl_boolean_model_efl_model_property_set(Eo *obj, Efl_Boolean_Model_Data *pd, const char *property, Eina_Value *value);


Eina_Value *_efl_boolean_model_efl_model_property_get(const Eo *obj, Efl_Boolean_Model_Data *pd, const char *property);


Efl_Object *_efl_boolean_model_efl_object_constructor(Eo *obj, Efl_Boolean_Model_Data *pd);


void _efl_boolean_model_efl_object_destructor(Eo *obj, Efl_Boolean_Model_Data *pd);


static Eina_Bool
_efl_boolean_model_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_BOOLEAN_MODEL_EXTRA_OPS
#define EFL_BOOLEAN_MODEL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_boolean_model_boolean_add, _efl_boolean_model_boolean_add),
      EFL_OBJECT_OP_FUNC(efl_boolean_model_boolean_del, _efl_boolean_model_boolean_del),
      EFL_OBJECT_OP_FUNC(efl_boolean_model_boolean_iterator_get, _efl_boolean_model_boolean_iterator_get),
      EFL_OBJECT_OP_FUNC(efl_model_properties_get, _efl_boolean_model_efl_model_properties_get),
      EFL_OBJECT_OP_FUNC(efl_model_property_set, _efl_boolean_model_efl_model_property_set),
      EFL_OBJECT_OP_FUNC(efl_model_property_get, _efl_boolean_model_efl_model_property_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_boolean_model_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_boolean_model_efl_object_destructor),
      EFL_BOOLEAN_MODEL_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_boolean_model_class_desc = {
   EO_VERSION,
   "Efl.Boolean_Model",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Boolean_Model_Data),
   _efl_boolean_model_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_boolean_model_class_get, &_efl_boolean_model_class_desc, EFL_COMPOSITE_MODEL_CLASS, NULL);
